stack/java-cache-backend/src/main/java/com/oracle/cloud/apaas/example/springboot/rest/entities/Customer.java
package com.oracle.cloud.apaas.example.springboot.rest.entities;

import org.springframework.stereotype.Component;

/**
 * @author pnagy
 *
 */
@Component
public class Customer {

	private String id;
	private String username;
	private String firstName;
	private String lastName;
	private String mobile;
	private String home;
	private String email;
	private String locationid;
	private Location address;

	public Customer() {
	}

	public Customer(String id, String username, String firstName, String lastName, Location location, String mobile,
			String home, String email) {
		super();
		this.id = id;
		this.username = username;
		this.firstName = firstName;
		this.lastName = lastName;
		this.address = location;
		this.locationid = location.getId();
		this.mobile = mobile;
		this.home = home;
		this.email = email;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getMobile() {
		return mobile;
	}

	public void setMobile(String mobile) {
		this.mobile = mobile;
	}

	public String getHome() {
		return home;
	}

	public void setHome(String home) {
		this.home = home;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getId() {
		return id;
	}

	public Location getaddress() {
		return address;
	}

	public void setAddress(Location address) {
		this.address = address;
	}
	
	public String getLocationid() {
		return locationid;
	}

	public void setLocationid(String locationId) {
		this.locationid = locationId;
	}
	
	public String getFormattedAddress() {
		return (getaddress() == null? "Address is not defined." : getaddress().getFormattedAddress());
	}

	public String toString() {
		StringBuffer sb = new StringBuffer();

		sb.append(getId()).append(", ");
		sb.append(getFirstName()).append(" ").append(getLastName()).append(", ");
		sb.append(getUsername()).append(", ");
		sb.append(getEmail()).append(", ");
		sb.append(getMobile()).append(", ");
		sb.append(getHome()).append(", ");
		sb.append((getaddress() == null? "Address is not defined." : getaddress().getFormattedAddress()));

		return sb.toString();
	}

}

stack/java-cache-backend/src/main/webapp/WEB-INF/views/customerform.jsp
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<html>
<head>
<link rel="stylesheet"
	href="//cdn.rawgit.com/yahoo/pure-release/v0.6.2/pure-min.css">
</head>
<body>
	<h1>Update Customer</h1>
	<form class="pure-form-aligned" action="/customerlist" method="POST">
	
		<fieldset>
			<div class="pure-control-group">
				<label>Customer ID</label> 
				<input name="id" type="text" value="${customer.id}" disabled>
				<input name="customerid" type="hidden" value="${customer.id}">
			</div>
			<div class="pure-control-group">
				<label >First Name</label>
				<input name="firstname" type="text" value="${customer.firstName}" placeholder="First Name">
			</div>
			<div class="pure-control-group">
				<label >Last Name</label>
				<input name="lastname" type="text" value="${customer.lastName}" placeholder="Last Name">
			</div>
			<div class="pure-control-group">
				<label >Username</label>
				<input name="username" type="text" value="${customer.username}" placeholder="username" disabled>
				
			</div>
			<div class="pure-control-group">
				<label >Email</label>
				<input name="email" type="text" value="${customer.email}" placeholder="username@example.com"
					disabled>
			</div>
			<div class="pure-control-group">
				<label >Mobile phone</label>
				<input name="mobile" type="text" value="${customer.mobile}" disabled>
			</div>
			<div class="pure-control-group">
				<label>Landline phone</label>
				<input name="home" type="text" value="${customer.home}" disabled>
			</div>
			<div class="pure-control-group">
				<label>Address</label>
				<input name="address" type="text" value="${customer.formattedAddress}" disabled>
			</div>			
		<input type="submit" class="pure-button pure-button-primary" value="Update">
		</fieldset>
	</form>
</body>
</html>

stack/java-cache-backend/src/main/webapp/WEB-INF/views/customerlist.jsp
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<html>
<head>
<link rel="stylesheet"
	href="//cdn.rawgit.com/yahoo/pure-release/v0.6.2/pure-min.css">
</head>
<body>
	<h1>Cache Customer list JSP</h1>
	
	<br>
	<a href="/">Back to main page</a>
	<br>

	<table class="pure-table pure-table-bordered">
		<tr>
			<th>Action</th>
			<th>Customer ID</th>
			<th>First Name</th>
			<th>Last Name</th>
			<th>Username</th>
			<th>Email</th>
			<th>Mobile phone</th>
			<th>Landline phone</th>
			<th>Address</th>
		</tr>
		<c:forEach items="${customers}" var="customer">
			<tr>
				<td><a href="customers/${customer.id}/update">Edit</a></td>
				<td>${customer.id}</td>
				<td>${customer.firstName}</td>
				<td>${customer.lastName}</td>
				<td>${customer.username}</td>
				<td>${customer.email}</td>
				<td>${customer.mobile}</td>
				<td>${customer.home}</td>
				<td>${customer.formattedAddress}</td>
			</tr>
		</c:forEach>
	</table>
</body>
</html>

stack/java-cache-backend/src/main/webapp/WEB-INF/views/environment.jsp
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<%@page import="java.util.TreeMap"%>
<%@page import="java.util.Collections"%>
<%@page import="java.util.Set"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.List"%>
<%@page import="java.lang.management.ManagementFactory"%>
<%@page import="java.lang.management.RuntimeMXBean"%>
<%@page import="java.lang.ClassLoader"%>
<%@ page import="org.slf4j.Logger"%>
<%@ page import="org.slf4j.LoggerFactory"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<style>
table {
	font-family: arial, sans-serif;
	border-collapse: collapse;
	width: 100%;
}

td, th {
	border: 1px solid #dddddd;
	text-align: left;
	padding: 8px;
}

tr:nth-child(even) {
	background-color: #dddddd;
}
</style>
<link rel="stylesheet"
	href="//cdn.rawgit.com/yahoo/pure-release/v0.6.2/pure-min.css">
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Application Container Cloud Service - Environment
	Variables</title>
</head>
<body>

	<h1>
		Welcome to <a href="https://cloud.oracle.com/acc" target="_blank"><font
			color="red">Oracle Application Container Cloud Service Demo</font></a>
	</h1>
	<p>
		This is a JavaSE back-end service for <a
			href="http://www.oracle.com/webfolder/technetwork/jet/globalExamples-App-FixItFast.html"
			target="_blank">Oracle JET FixItFast demo</a> application using <a
			href="http://docs.oracle.com/en/cloud/paas/app-container-cloud/cache/typical-workflow-creating-and-using-caches.html"
			target="_blank">Caches in Oracle Application Container Cloud
			Service</a>
	</p>

	Links to test services:
	<br>
	<a href="/customerlist">Edit Customers</a>
	<br>
	<a href="customers">Customers - REST Service</a>
	<br>
	<a href="/locations">Locations - REST Service</a>
	<br>
	<h3>Environment Variables for current Application Container Cloud
		Service</h3>
	<table class="pure-table pure-table-bordered">
		<tr>
			<th>Name</th>
			<th>Value</th>
		</tr>
		<%
			Logger logger = LoggerFactory.getLogger(this.getClass());
			TreeMap<String, String> sortedMap = new TreeMap<String, String>();
			sortedMap.putAll(System.getenv());
			for (Map.Entry<String, String> f : sortedMap.entrySet()) {
				out.println("<tr><td><b>");
				out.println(f.getKey());
				out.println("</b></td><td>");
				out.println(f.getValue());
				out.println("</td></tr>");
			}
			RuntimeMXBean runtimeMxBean = ManagementFactory.getRuntimeMXBean();
			List<String> arguments = runtimeMxBean.getInputArguments();
			String sJavaagentArg = "-javaagent option was not defined.";
			for (String argument : arguments) {
				if (argument.startsWith("-javaagent:")) {
					sJavaagentArg = argument;
					break;
				}
			}
			out.println("<tr><td><b>Java Agent</b> (RuntimeMXBean)</td><td>" + sJavaagentArg + "</td></tr>");
			try {
				java.lang.reflect.Method m = ClassLoader.class.getDeclaredMethod("findLoadedClass",
						new Class[] { String.class });
				m.setAccessible(true);
				ClassLoader cl = ClassLoader.getSystemClassLoader();
				Object oAgent = m.invoke(cl, "oracle.apmaas.agent.instrumentation.Agent");
				out.println("<tr><td><b>oracle.apmaas.agent.instrumentation.Agent</b></td><td>Agent is "
						+ (oAgent != null ? "" : "not") + " loaded.</td></tr>");
			} catch (Exception e) {
				logger.error("Searching APM Agent class failed", e);
			}
		%>

	</table>

	<br>
	<a href="applog">Spring Boot application log</a>
	<br>
	<a href="agentlog">APM agent log (if deployed)</a>
</body>
</html>